"""
Tests for workflow.message_architect
"""
from datetime import datetime

import pytest
from immutable_views import DictView
from workspaces.workflow.message_architect import WorkflowMessageArchitect
from workspaces.workflow.schema import WorkflowRequest

r1 = WorkflowRequest(
    workflow_request_id=-1,
    workflow_name="null",
    argument={"parameters": "-g"},
    state="Ready",
    results_dir="",
    created_at=datetime(1996, 9, 10),
    updated_at=datetime(1996, 9, 10),
)


class TestCapabilityMessageArchitect:
    @pytest.mark.skip("tests hanging in pipeline")
    def test_get_message_template(self):
        execution_msg = WorkflowMessageArchitect(request=r1).get_message_template("workflow_failed")
        assert execution_msg == DictView(
            {
                "service": "workflow",
                "routing_key": "workflow",
                "subject": None,
                "type": "workflow-failed",
            }
        )

        request_msg = WorkflowMessageArchitect(previous_info=r1).get_message_template("ingestion_complete")
        assert request_msg == DictView(
            {
                "service": "workflow",
                "routing_key": "workflow",
                "subject": None,
                "type": "ingestion-complete",
            }
        )

    @pytest.mark.skip("tests hanging in pipeline")
    def test_compose_msg(self):
        execution_msg = WorkflowMessageArchitect(request=r1).compose_message("workflow_failed")
        assert execution_msg == DictView(
            {
                "service": "workflow",
                "routing_key": "workflow",
                "subject": r1,
                "type": "workflow-failed",
            }
        )
